unit MainProg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,mxarrays, Grids, Buttons,IDGlobal,office2000,
  OleServer, Excel2000;

 type DD=Array of integer;
type
   TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Button2: TButton;
    Memo2: TMemo;
    Memo3: TMemo;
    GroupBox1: TGroupBox;
    Edit4: TEdit;
    Label10: TLabel;
    RadioGroup2: TRadioGroup;
    GroupBox2: TGroupBox;
    RadioGroup1: TRadioGroup;
    Edit3: TEdit;
    Label9: TLabel;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    Memo4: TMemo;
    Label11: TLabel;
    Edit5: TEdit;
    Label12: TLabel;
    Edit6: TEdit;
    Label13: TLabel;
    RadioGroup3: TRadioGroup;
    StringGrid1: TStringGrid;
    Button3: TButton;
    Button4: TButton;
    ExcelApplication1: TExcelApplication;
    SaveDialog1: TSaveDialog;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    Function OpenMYDialog(const ACaption, APrompt: string;Kind:Integer): String;
    Procedure SetBasicArray(JobCount:Integer);
    Procedure SetJobArray(JobCount:Integer);
    Procedure SetMemoText(Vm:TMemo;S:String);
    procedure BitBtn1Click(Sender: TObject);
    Function CountDelayDay(CountArray:DD;Delayday:Integer):integer;
    Function FirstCount(CountArray:DD):integer;
    Procedure Setmemo(Varray:DD);
    Procedure SetEdit;
    Procedure CLearMemo;
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
    Function SetRandom(Min,Max,Job_Amount:integer;Flag:Boolean):DD;
    Function  GetRanDomValue(Min,Max:Integer):integer;
    Procedure SetArrayLength(I:integer);
    Procedure CountGetMin;
    Procedure CountByJob;
    Procedure CountByFinishDay;
    Procedure CountByEndDay;
    Procedure ClearStringGrid;
    Function  MyArraySort(Varray: DD): DD;
    Function  GetArrayValue(S,CC:String):Integer;
    Procedure SetStringGrid(Varray:DD);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    { Private declarations }
  public

    { Public declarations }
  end;

var
  Form1: TForm1;
  Work_Amount:integer;
  Needdate:DD;
  FinishDay:DD;
  Job_No:DD;
  FF:TStringList;
  VV:Double;
implementation

      var// ResultArray:array of DD;
          ResultTemp:DD;
          MinDelayDay:integer;
          Count:integer;//OStringGridOĴX
          TotalResult:integer;//OXոƥiͳ̤p;
{$R *.dfm}

Procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
 begin
    if not (key in ['0'..'9',#8]) then
      key:=#0;
end;

Procedure TForm1.Button1Click(Sender: TObject);
 Begin
    If Trim(Edit1.Text)='' then
        Edit1.Text:='3';
    CLearMemo;
    SetArrayLength(StrToInt(Edit1.Text));
    SetBasicArray(StrToInt(Edit1.Text));
    Repaint;
 end;


Function TForm1.OpenMYDialog(const ACaption, APrompt: string; Kind: Integer): String;
 var Form:Tform;
     Lb:TLabel;
     ED:TEdit;
begin
   Form:=TForm.Create(Application);
     With Form do
         BEgin
          try
              Canvas.Font := Font;
              Color:=clSkyBlue;
              BorderStyle := bsDialog;
              Caption := ACaption;
              Height:=180;
              Width:=300;
              Position := poMainFormCenter;
              Lb := TLabel.Create(Form);
              with Lb do
              begin
                Parent := Form;
                Caption := APrompt;
                Left := 90;
                Lb.Height:=20;
                Top := 30;
                Width := 200;
                Transparent:=true;
                ParentColor:=true;
                AutoSize:=False;
                WordWrap := True;
              end;
                  ED := TEdit.Create(Form);
                    with Ed do
                       begin
                        Parent := Form;
                        Left := Lb.Left;
                        CharCase:=ecUpperCase;
                        Top := Lb.Top + Lb.Height + 5;
                        Width := 100;
                        MaxLength := 255;
                        SelectAll;
                      end;
   with TButton.Create(Form) do
      begin
        Parent := Form;
        Caption := 'Tw';
        Left:=Round((Form.Width)/2)-70;
        ModalResult := mrOk;
        Top:=90;
        Default := True;
      end;
      with TButton.Create(Form) do
      begin
        Parent := Form;
        Caption := '';
        Left:=Round((Form.Width)/2)+10;
        ModalResult := mrCancel;
        Cancel := True;
        Top:=90;
      end;

        if ShowModal = mrOk then
           Begin
               If Trim(ED.Text)='' then
                    Result:='4'
                else
                    Result:=ED.Text;
           End
        Else
           Begin
              Result:='';
              ShowMessage('պN|!');
              Abort;
              Exit;
           End;
    finally
       FreeAndNil(Lb);
       FreeAndNil(ED);
       FreeAndNil(Form);
    end;
    End;
  end;


procedure TForm1.SetBasicArray(JobCount: Integer);
var I:integer;
    S:String;
 Begin

    If Trim(Edit1.Text)='' then
        Edit1.Text:='3';
       For I:=0 to JobCount-1 do
           Begin
              S:=OpenMYDialog('u'+IntToStr(I+1)+'BzɶPJ','u'+IntToStr(I+1)+'BzɶPJG',0);
              Needdate[I]:=StrToInt(S);
              SetMemoText(Memo2,'u'+IntToStr(I+1)+'BzɶPJ:'+S);
           End;
       For I:=0 to StrToInt(Edit1.Text)-1 do
           Begin
              S:=OpenMYDialog('u'+IntToStr(I+1)+'DJ','u'+IntToStr(I+1)+'DJG',0);
              FinishDay[I]:=StrToInt(S);
              SetMemoText(Memo3,'u'+IntToStr(I+1)+'DJ:'+S);
           End;
   end;
procedure TForm1.SetMemoText(VM:TMemo;S:String);
begin
   Vm.Lines.Add(S);
end;

Procedure TForm1.SetJobArray(JobCount: Integer);
 Var i:integer;
Begin
 For i:=0 to JobCount-1 do
    Begin
       Job_No[I]:=I+1;
    end;

end;



Function TForm1.CountDelayDay(CountArray: DD;Delayday:Integer):Integer;
  Var I,Total_WorkDay:integer;
Begin
   Result:=0;
   Total_WorkDay:=0;
   For I:=Low(CountArray) to High(CountArray) do
         begin
             If Needdate[CountArray[I]-1]+Total_WorkDay-FinishDay[CountArray[I]-1] >= 0 then
                  Result:=Result+Needdate[CountArray[I]-1]+Total_WorkDay-FinishDay[CountArray[I]-1];

                 If Result > Delayday then
                     Begin
                     //   Result:=Delayday;
                        Break;
                     end
                 else
                     begin
                         Result:=Result;
                     end;
                     Total_WorkDay:=Total_WorkDay+NeedDate[CountArray[I]-1];
         end;     //pGֿnu@Ѽ>u[I],֥[Ѽ
    if Result < Delayday then
        Begin
          MinDelayDay:=Result;
          Setmemo(CountArray);
          ClearStringGrid;
          SetStringGrid(CountArray);
          Count:=Count+5;
        End
    Else if Result = Delayday then
        Begin
          MinDelayDay:=Result;
          SetStringGrid(CountArray);
          Count:=Count+5;
          TotalResult:=TotalResult+1;
        End
    Else
         Result:=Delayday;
end;

Function TForm1.FirstCount(CountArray: DD): integer;
  Var I,Total_WorkDay:integer;
Begin
  Result:=0;
  Total_WorkDay:=0;
  Work_Amount:=0;
   For I:=Low(CountArray) to High(CountArray) do
         begin

             If Needdate[CountArray[I]-1]+Total_WorkDay-FinishDay[CountArray[I]-1] > 0 then
                 begin
                   Result:= Result+Needdate[CountArray[I]-1]+Total_WorkDay-FinishDay[CountArray[I]-1];
                 End;
                   Work_Amount:=Work_Amount+Needdate[CountArray[I]-1];
           Total_WorkDay:=Total_WorkDay+NeedDate[CountArray[I]-1];
 end;
 Setmemo(CountArray);
 SetStringGrid(CountArray);
 Count:=Count+5;
end;

Procedure TForm1.Setmemo(Varray:DD);
  Var I,WorkDaySum:integer;
Begin
Memo1.Clear;
Memo4.Clear;
WorkDaySum:=0;
   For i:=Low(VArray) to High(Varray) do
      Begin
          Memo1.Lines.Add(IntToStr(I+1)+'Gu'+IntToStr(Varray[I]));
          WorkDaySum:=WorkDaySum+NeedDate[Varray[I]-1];
          Memo4.Lines.Add('u'+IntToStr(Varray[I])+'uɶG'+IntToStr(WorkDaySum));
      end;
end;

Procedure TForm1.Edit3KeyPress(Sender: TObject; var Key: Char);
Begin
if not (key in ['0'..'9',#8]) then
    key:=#0;

end;

Procedure TForm1.Button2Click(Sender: TObject);
 Var i:integer;
Begin
If Trim(Edit2.Text)='' then
     Begin
       ShowMessage('пJ`u@Ѽ!');
       Edit2.SetFocus;
     End
 else
    Begin

CLearMemo;
SetEdit;
SetArrayLength(StrToInt(Edit1.Text));
Case RadioGroup1.ItemIndex of
   0:
      Begin
         Needdate:=SetRandom(StrToInt(Edit3.Text),StrToInt(Edit6.Text),StrToInt(Edit1.Text),False);
           For i:=Low(Needdate) to High(Needdate) do
               Begin
                 SetMemoText(Memo2,'u'+IntToStr(I+1)+'BzɶPJ:'+IntToStr(NeedDate[i]));
              end;
      End;
   1:
      Begin
         Needdate:=SetRandom(StrToInt(Edit3.Text),StrToInt(Edit6.Text),StrToInt(Edit1.Text),True);
             For i:=Low(Needdate) to High(Needdate) do
               Begin
                 SetMemoText(Memo2,'u'+IntToStr(I+1)+'BzɶPJ:'+IntToStr(NeedDate[i]));
              end;
      End;
  end;

Case RadioGroup2.ItemIndex of
   0:
      Begin
         FinishDay:=SetRandom(StrToInt(Edit4.Text),StrToInt(Edit5.Text),StrToInt(Edit1.Text),False);
             For i:=Low(FinishDay) to High(FinishDay) do
               Begin
                 SetMemoText(Memo3,'u'+IntToStr(I+1)+'DJ:'+IntToStr(FinishDay[i]));
              end;
      End;

   1:
     Begin
       FinishDay:=SetRandom(StrToInt(Edit4.Text),StrToInt(Edit5.Text),StrToInt(Edit1.Text),True);
             For i:=Low(FinishDay) to High(FinishDay) do
                 Begin
                   SetMemoText(Memo3,'u'+IntToStr(I+1)+'DJ:'+IntToStr(FinishDay[i]));
                 end;
     End;
  end;
 End;
end;

Function TForm1.SetRandom(Min,Max,Job_Amount: integer; Flag: Boolean):DD;
 Var A:integer;
Begin
//Flag=true ]wd
//Flag= fALSE ]wd
SetLength(Result,Job_Amount);
If Flag=True then
    begin
       For A:=0 to Job_Amount-1 do
          begin
             Result[A]:=GetRanDomValue(Min,Max);
          end;
    end
 Else
    Begin
       For A:=0 to Job_Amount-1 do
          begin
             Result[A]:=GetRanDomValue(Min,MaxInt);
          end;
    End;
end;

Procedure TForm1.CLearMemo;
begin
      Memo1.Clear;
      Memo2.Clear;
      Memo3.Clear;
      Memo4.Clear;
end;

Procedure TForm1.SetEdit;
begin
   If Trim(Edit3.Text)='' then
         Edit3.Text:='1';

   If Trim(Edit6.Text)='' then
         Edit6.Text:='5';

   If Trim(Edit4.Text)='' then
         Edit4.Text:='1';

   If Trim(Edit5.Text)='' then
         Edit5.Text:=Edit2.Text;
end;

Function TForm1.GetRanDomValue(Min,Max:Integer): integer;
 begin
    Repeat     //OҤX{0
        Result:=Random(Max+1);
    Until((Result<>0) and (Result>=Min));
end;

Procedure TForm1.SetArrayLength(I: integer);
Begin
     Job_No:=Nil;
     Needdate:=nil;
     FinishDay:=nil;
     SetLength(job_no,I);
     SetLength(needdate,I);
     SetLength(finishDay,I);
     SetJobArray(I);
end;

Procedure TForm1.CountGetMin;
  Procedure ArrayCom(const a1:array of integer;s:string;L:TStrings);
    Var i,j,t : integer;
         b1,Temp:DD;
         s1,A:string;
  Begin

    Setlength(Temp,High(a1)+1);
    for i:=Low(a1) to High(a1) do
         Temp[i] := a1[i];

    for i:=Low(a1) to High(a1) do
        begin
              t := temp[0];
              temp[0] := temp[i];
              temp[i] := t;
              setlength(b1,High(a1));

              For j := 0 to High(b1) do
                 b1[j] := temp[j+1];

              s1 := inttostr(temp[0])+ ',';
              ArrayCom(b1, s + s1, L);
         end;
    if High(a1)=0 then
        Begin
          A:='';
          A:=S+S1;
            For I:=0 to High(job_no) do
                 Begin
                    ResultTemp[I]:=StrToInt(fetch(A,',',true));
                 End;

           If VV=0 then
                MinDelayDay:=FirstCount(ResultTemp)
           else
               Begin
                 CountDelayDay(ResultTemp,MinDelayDay);
               End;
//           ResultArray[vv]:=ResultTemp;
           vv:=vv+1;
        End;
  End;
var //I,X:integer;
    StartTime:Ttime;
Begin
If Trim(Edit2.Text)='' then
     Begin
       ShowMessage('пJ`u@Ѽ!');
       Edit2.SetFocus;
     End
 else
    Begin
      StartTime:=Time;
//      X:=job_no[0];

      SetLength(ResultTemp,High(Job_no)+1);
      StringGrid1.ColCount:=High(Job_no)+3;

{

  For i:=1 to high(Job_no) do
       X:=X*Job_no[i];

  SetLength(ResultTemp,High(Job_no)+1);
  SetLength(ResultArray,X);

   For I:=0 to X-1 do
       SetLength(ResultArray[i],High(Job_no)+1);//Set resultarray
 }
     VV:=0;
     Count:=0;
     ArrayCom(Job_no,'',nil);
     Label3.Caption:='ɶG'+TimeToStr(Time-StartTime);
     Label4.Caption:='̤pѼơG'+IntToStr(MinDelayDay);
     Label8.Caption:='`u@ѼơG'+IntToStr(Work_Amount);
     ShowMessage('槹!@'+IntToStr(TotalResult)+'ոƥiͳ̨θ!');
   End;
end;


Procedure TForm1.CountByEndDay;
  Var StartTime:Ttime;
begin
    StartTime:=Time;
    SetJobArray(StrToInt(Trim(Edit1.Text)));
    Label3.Caption:='ɶG'+TimeToStr(Time-StartTime);
    Label4.Caption:='̤pѼơG'+IntToStr(FirstCount(MyArraySort(Needdate)));
    Label8.Caption:='`u@ѼơG'+IntToStr(Work_Amount);
    ShowMessage('槹');
end;

Procedure TForm1.CountByFinishDay;
 Var StartTime:Ttime;
Begin
    StartTime:=Time;
    SetJobArray(StrToInt(Trim(Edit1.Text)));
    Label3.Caption:='ɶG'+TimeToStr(Time-StartTime);
    Label4.Caption:='̤pѼơG'+IntToStr(FirstCount(MyArraySort(FinishDay)));
    Label8.Caption:='`u@ѼơG'+IntToStr(Work_Amount);
    ShowMessage('槹');
End;

Procedure TForm1.CountByJob;
 Var StartTime:Ttime;
Begin
    StartTime:=Time;
    SetJobArray(StrToInt(Trim(Edit1.Text)));
    Label3.Caption:='ɶG'+TimeToStr(Time-StartTime);
    Label4.Caption:='̤pѼơG'+IntToStr(FirstCount(Job_No));
    Label8.Caption:='`u@ѼơG'+IntToStr(Work_Amount);
    ShowMessage('槹');
End;

Procedure TForm1.BitBtn1Click(Sender: TObject);
  Begin
Case RadioGroup3.ItemIndex of
   0:CountGetMin;
   1:CountByJob;
   2:CountByEndDay;
   3:CountByFinishDay;
 End;
end;

Function TForm1.MyArraySort(Varray: DD): DD;
  Var I : integer;
      S:TStringlist;
begin
   S:=TStringList.Create;
   SetLength(Result,High(Varray)+1);
   For I := Low(Varray) To High(Varray) do
         begin
             If Varray[I]<10 then
                 S.Add('0'+IntToStr(Varray[I])+','+IntToStr(job_no[I]))
             Else
                 S.Add(IntToStr(Varray[I])+','+IntToStr(job_no[I]));
         End;
       S.Sort;
  For I := 0 To S.Count - 1 do
       Begin
         Result[I] :=GetArrayValue(S[I],',');
       End;
end;



Function TForm1.GetArrayValue(S, CC: String): Integer;
 Var i,J:Integer;
    V:String;
Begin
 V:='';
 For i:= 1 to Length(S) do
      Begin
        If S[I]=CC then
            Begin
               For J:=I+1 to Length(S) do
                  Begin
                      V:=V+S[J];
                  End;
              Break;
            End;
      End;
  Result:=StrToInt(V);

end;

Procedure TForm1.SetStringGrid(Varray: DD);
 Var I,WorkDaySum,Total_WorkDay,delaydd,Total_delay1,Total_delay2:integer;

begin
  delaydd:=0;
  WorkDaySum:=0;
  Total_WorkDay:=0;
  Total_delay1:=0;
  Total_delay2:=0;
          StringGrid1.Cells[0,count]:='u涶';
          StringGrid1.Cells[0,count+1]:='u󧹤uɶ';
          StringGrid1.Cells[0,count+2]:='u󩵿ɶ(u)';
          StringGrid1.Cells[0,count+3]:='u󩵿ɶ(ut)';

   For i:=Low(VArray) to High(Varray) do
      Begin
          StringGrid1.RowCount:=StringGrid1.RowCount+1;
          StringGrid1.Cells[I+1,Count]:='u'+IntToStr(Varray[I]);
          WorkDaySum:=WorkDaySum+NeedDate[Varray[I]-1];
          StringGrid1.Cells[I+1,Count+1]:=IntToStr(WorkDaySum);
          delaydd:=Needdate[VArray[I]-1]+Total_WorkDay-FinishDay[VArray[I]-1];
          Total_WorkDay:=Total_WorkDay+NeedDate[VArray[I]-1];
          If delaydd > 0 then
               Begin
                 StringGrid1.Cells[I+1,Count+2]:=IntToStr(delaydd);
                 Total_delay1:=Total_delay1+delaydd;
               End
          Else
               StringGrid1.Cells[I+1,Count+2]:='0';


          If delaydd < 0 then
              Begin
               StringGrid1.Cells[I+1,Count+3]:=IntToStr(delaydd);
               Total_delay2:=Total_delay2+delaydd;
              End
          Else
               StringGrid1.Cells[I+1,Count+3]:='0' ;
      end;
     StringGrid1.Cells[high(varray)+2,count+2]:=IntToStr(Total_delay1);
     StringGrid1.Cells[high(varray)+2,count+3]:=IntToStr(Total_delay2);

end;

Procedure TForm1.Button3Click(Sender: TObject);
 Begin
      StringGrid1.ColCount:=High(Job_no)+3;
      StringGrid1.RowCount:=1;
 end;

Procedure TForm1.ClearStringGrid;
  Var I:integer;
Begin
  For I:= 0 to StringGrid1.ColCount-1 do
          StringGrid1.Cols[i].Clear;

  For I:= 0 to StringGrid1.RowCount-1 do
          StringGrid1.Rows[i].Clear;

    Count:=0;
    StringGrid1.RowCount:=1;
    TotalResult:=1;
end;

Procedure TForm1.Button4Click(Sender: TObject);
  Var asheet:Variant;
      i,j:integer;
Begin
  ExcelApplication1.Workbooks.add(xlWBATWorksheet,0);
  asheet:=ExcelApplication1.Worksheets.item[1];
 For i:=0 to StringGrid1.ColCount-1 do
    begin
       for j:=0 to StringGrid1.RowCount-1 do
           begin
              asheet.cells[J+1,I+1].value:=StringGrid1.Cells[I,j];
           end;
     end;
if SaveDialog1.Execute then
   begin
   if FileExists(SaveDialog1.FileName) then
    if MessageDlg('ɮפwgsbAO_nл\?',mtConfirmation,[mbYes,mbNo,mbCancel],0)<>mrYes then
        exit;
    asheet.saveAs(SaveDialog1.FileName);
    asheet.Application.quit;
  end;
end;

end.
